config/routes.rb
Rails.application.routes.draw do
  devise_for :usuarios
  root to: 'painel#index'

  resources :alunos
  resources :livros
  resources :materias
  resources :cursos
  resources :semestres
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/livro.rb
class Livro < ApplicationRecord
  paginates_per 5

  belongs_to :curso
  belongs_to :semestre
  belongs_to :materia

  def self.search(search)
    where('titulo like ?', "%#{search}%").order(:titulo)
  end
end

app/controllers/livros_controller.rb
class LivrosController < ApplicationController
  before_action :set_livro, only: %i[show edit update destroy]
  before_action :authenticate_usuario!
  # GET /livros
  # GET /livros.json
  def index
    @livros = if params[:search].present?
                Livro.search(params[:search]).page params[:page]
              else
                Livro.order(:autor).page params[:page]
    end
  end

  # GET /livros/1
  # GET /livros/1.json
  def show; end

  # GET /livros/new
  def new
    @livro = Livro.new
  end

  # GET /livros/1/edit
  def edit; end

  # POST /livros
  # POST /livros.json
  def create
    @livro = Livro.new(livro_params)

    respond_to do |format|
      if @livro.save
        format.html { redirect_to @livro, notice: t('.new', default: t('helpers.messages.new')) }
        format.json { render :show, status: :created, location: @livro }
      else
        format.html { render :new }
        format.json { render json: @livro.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /livros/1
  # PATCH/PUT /livros/1.json
  def update
    respond_to do |format|
      if @livro.update(livro_params)
        format.html { redirect_to @livro, alert: t('.update', default: t('helpers.messages.update')) }
        format.json { render :show, status: :ok, location: @livro }
      else
        format.html { render :edit }
        format.json { render json: @livro.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /livros/1
  # DELETE /livros/1.json
  def destroy
    @livro.destroy
    respond_to do |format|
      format.html { redirect_to livros_url, alert: t('.destroy', default: t('helpers.messages.destroy')) }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_livro
    @livro = Livro.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def livro_params
    params.require(:livro).permit(:autor, :titulo, :ano_publicacao, :curso_id, :semestre_id, :materia_id, :search)
  end
end

app/helpers/livros_helper.rb
module LivrosHelper
end

app/views/livros/_form-search.html.erb
<div class="row justify-content-first">
  <div class="col-12 mb-3">
    <%= form_tag livros_path, method: :get, class: "navbar-form form-inline search-form" do %>
    <div class="form-group">
      <%= label_tag :search, "Pesquisar", class: "mr-2" %>
      <%= text_field_tag(:search, params[:search], placeholder: "Ex: Programação", class: "form-control float-left mr-2" ) %>
    </div>
    <div class="form-group">
      <%= submit_tag "Pesquisar", class: "btn btn-primary float-right" %>
    </div>
  <% end %>
</div>
</div>

app/views/livros/_form.html.erb
<%= form_with(model: livro, local: true) do |form| %>
<% if livro.errors.any? %>
  <div class="alert alert-danger">
    <h2><%= pluralize(livro.errors.count, "error") %>
      prohibited this livro from being saved:</h2>

    <ul>
      <% livro.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
    </ul>
  </div>
<% end %>

<div class="form-group">
  <%= form.label :autor %>
  <%= form.text_field :autor, class: "form-control" %>
</div>

<div class="form-group">
  <%= form.label :titulo %>
  <%= form.text_field :titulo, class: "form-control" %>
</div>

<div class="form-group">
  <%= form.label :ano_publicacao %>
  <br>
  <%= form.date_select :ano_publicacao, {start_year: 1900, use_month_numbers: true},{class: "form-control mr-2", style: "float:left; width: 100px;"} %>
  <br>
</div>
<div class="form-group">
  <%= form.label :curso_id %>
  <%= form.collection_select :curso_id, Curso.order(:descricao), :id, :descricao,{prompt: "Selecione o curso"}, {class: "form-control"} %>
</div>

<div class="form-group">
  <%= form.label :semestre_id %>
  <%= form.collection_select :semestre_id, Semestre.order(:descricao), :id, :descricao,{prompt: "Selecione o semestre"}, {class: "form-control"} %>
</div>

<div class="form-group">
  <%= form.label :materia_id %>
  <%= form.collection_select :materia_id, Materia.order(:descricao), :id, :descricao,{prompt: "Selecione a matéria"}, {class: "form-control"} %>
</div>

<div class="form-group">
  <%= form.submit nil, class: "btn btn-primary" %>
</div>
<% end %>

app/views/livros/edit.html.erb
<%= title "Editar Livro" %>
<% model_class = Livro %>
  <div class="container">
    <div class="row">
      <div class="col-lg-12 mb-3">
        <h1 class="mt-2 pb-2"><%= t('.edit', :default=> t('helpers.title.edit', :model=> model_class.model_name.human.titleize)) %></h1>

        <%= render 'form', livro: @livro %>

        <%= link_to t('.show', :default=> t('helpers.submit.show')), @livro, class: "btn btn-info btn-sm" %>
        |
        <%= link_to t('.back', :default=> t('helpers.submit.back')), livros_path, class: "btn btn-danger btn-sm" %>
      </div>
    </div>
  </div>

app/views/livros/index.html.erb
<%= title "Livros" %>
<div class="container">
  <div class="row">
    <div class="col-lg-12">
      <% model_class = Livro %>
        <h1 class="mt-2 pb-2"><%= t('.list', :default=> t('helpers.title.list', :model=> model_class.model_name.human.titleize.pluralize)) %></h1>
        <%= render partial: 'form-search' %>
        <div class="table-responsive">
          <table class="table table-striped table-hover">
            <thead class="thead-dark">
              <tr>
                <th scope="col">#</th>
                <th scope="col"><%= model_class.human_attribute_name(:autor) %></th>
                <th scope="col"><%= model_class.human_attribute_name(:titulo) %></th>
                <th scope="col"><%= model_class.human_attribute_name(:ano_publicacao) %></th>
                <th scope="col"><%= model_class.human_attribute_name(:curso_id) %></th>
                <th scope="col"><%= model_class.human_attribute_name(:semestre_id) %></th>
                <th scope="col"><%= model_class.human_attribute_name(:materia_id) %></th>
                <th scope="col" colspan="3" class="text-center"><%= t('.options', :default=> t('helpers.options')) %></th>
              </tr>
            </thead>

            <tbody>
              <% @livros.each do |livro| %>
                <tr>
                  <th scope="row"><%= livro.id %></th>
                  <td><%= livro.autor %></td>
                  <td><%= livro.titulo %></td>
                  <td><%= livro.ano_publicacao.strftime("%d/%m/%Y") %></td>
                  <td><%= livro.curso.descricao %></td>
                  <td><%= livro.semestre.descricao %></td>
                  <td><%= livro.materia.descricao %></td>
                  <td><%= link_to t('.show', :default=> t('helpers.submit.show')), livro, class: "btn btn-outline-info btn-sm" %></td>
                  <td><%= link_to t('.edit', :default=> t('helpers.submit.edit')), edit_livro_path(livro), class: "btn btn-outline-success btn-sm" %></td>
                  <td><%= link_to t('.delete', :default=> t('helpers.submit.delete')), livro, class: "btn btn-outline-danger btn-sm", method: :delete, data: { confirm: t('.delete', :default=> t('helpers.messages.delete')) } %></td>
                </tr>
              <% end %>
            </tbody>
          </table>
        </div>
        <br>
        <%= link_to t('.new', :default=> t('helpers.submit.new')), new_livro_path, class: "btn btn-primary" %>
        <div class="row justify-content-center mb-3">
          <div class="col-6">
            <div class="row justify-content-end">
              <%= page_entries_info @livros, entry_name: "#{model_class.model_name.human.titleize}(s)" %>
            </div>
          </div>
          <div class="col-6">
            <div class="row justify-content-end">
              <%= paginate @livros, theme: 'twitter-bootstrap-4', pagination_class: "pagination-sm" %>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

app/views/livros/new.html.erb
<%= title "Cadastrar Livro" %>
<div class="container">
  <div class="row">
    <div class="col-lg-12">
      <% model_class = Livro%>
        <h1 class="mt-2 pb-2"><%= t('.new', :default=> t('helpers.title.new', :model=> model_class.model_name.human.titleize)) %></h1>

        <%= render 'form', livro: @livro %>

        <%= link_to t('.back', :default=> t('helpers.submit.back')), livros_path, class: "btn btn-danger btn-sm" %>
      </div>
    </div>
  </div>

app/views/livros/show.html.erb
<%=title "Visualizar Livro" %>
<% model_class = Livro %>
  <div class="container">
    <div class="row">
      <div class="col-4">
        <div class="card bg-light text-black mt-3">
          <div class="card-header bg-primary text-white">
            <h4><%= model_class.model_name.human.titleize %></h4>
          </div>
          <div class="card-body">
            <p class="card-text">
              <strong><%= model_class.human_attribute_name(:autor) %>:</strong>
              <%= @livro.autor %>
              <br>
              <strong><%= model_class.human_attribute_name(:titulo) %>:</strong>
              <%= @livro.titulo %>
              <br>
              <strong><%= model_class.human_attribute_name(:ano_publicacao) %>:</strong>
              <%= @livro.ano_publicacao %>
              <br>
              <strong><%= model_class.human_attribute_name(:curso_id) %>:</strong>
              <%= @livro.curso.descricao %>
              <br>
              <strong><%= model_class.human_attribute_name(:semestre_id) %>:</strong>
              <%= @livro.semestre.descricao %>
              <br>
              <strong><%= model_class.human_attribute_name(:materia_id) %>:</strong>
              <%= @livro.materia.descricao %>
            </p>
          </div>
          <div class="card-footer">
            <%= link_to t('.edit', :default=> t('helpers.submit.edit')), edit_livro_path(@livro), class: "btn btn-success btn-sm" %>
            |
            <%= link_to t('.back', :default=> t('helpers.submit.back')), livros_path, class: "btn btn-danger btn-sm" %>
          </div>
        </div>
      </div>
    </div>
  </div>